4. Configuración de Cluster Suite

Daniel Eugenin M. -

En modo gráfico:

system-config-cluster

 

* Vista inicial:

Captura_de_pantalla_2012-12-12_a_la_s__17.53.00.png


* Definición de los  Cluster Nodes:

Captura_de_pantalla_2012-12-12_a_la_s__17.53.57.png


Captura_de_pantalla_2012-12-12_a_la_s__17.54.16.png


* Definición de los Fence Devices: (manual fencing es utilizado sólo como laboratorio, nunca para ambientes productivos)

Captura_de_pantalla_2012-12-12_a_la_s__17.55.21.png


Captura_de_pantalla_2012-12-12_a_la_s__17.56.00.png


* Volver a seleccionar cada nodo, y luego agregarle el Fence recién creado:

Captura_de_pantalla_2012-12-12_a_la_s__17.57.21.png


* Agregar los recursos de cluster:

- IP Flotante

Captura_de_pantalla_2012-12-12_a_la_s__17.58.35.png


- Script de Apache

Captura_de_pantalla_2012-12-12_a_la_s__17.59.02.png


- Script de DRBD

Captura_de_pantalla_2012-12-12_a_la_s__17.59.21.png


Nota: el script de DRBD es uno creado sólo para setear el drbd como primary-secondary:

#!/bin/bash 
#
# chkconfig: 2345 71 79
# description: Loads and unloads the drbd module
DEFAULTFILE="/etc/default/drbd"
DRBDADM="/sbin/drbdadm"
if [ -f $DEFAULTFILE ]; then
. $DEFAULTFILE
fi
if [ "$#" -eq 2 ]; then
RES="$1"
CMD="$2"
else
RES="all"
CMD="$1"
fi
RES="all"
case "$CMD" in
start)
try=6
while true; do
$DRBDADM primary $RES && break
let "--try" || exit 1 # LSB generic error
sleep 1
done
;;
stop)
$DRBDADM secondary $RES
ex=$?
case $ex in
0)
exit 0
;;
11)
echo >&2 "$DRBDADM secondary $RES: exit code $ex, mapping to 1"
exit 1 # LSB generic error
;;
*)
echo >&2 "$DRBDADM secondary $RES: exit code $ex, mapping to 0"
exit 0
;;
esac
;;
status)
#if [ "$RES" = "all" ]; then
# echo "A resource name is required for status inquiries."
# exit 10
#fi
ST=$( $DRBDADM role $RES )
STATE=${ST%/*}
case $STATE in
Primary)
echo "running (Primary)"
exit 0 # LSB status "service is OK"
;;
Secondary|Unconfigured)
echo "stopped ($STATE)" ;;
"")
echo "stopped" ;;
*)
# unexpected. whatever...
echo "stopped ($ST)" ;;
esac
exit 3 # LSB status "service is not running"
;;
*)
echo "Usage: drbddisk {start|stop|status}"
exit 1
;;
esac
exit 0

 

- Punto de montaje (filesystem)

Captura_de_pantalla_2012-12-12_a_la_s__17.59.46.png



* Crear un nuevo servicio e ir asociando los recursos creados anteriormente en cascada como dependencia de uno con otro:

Captura_de_pantalla_2012-12-12_a_la_s__18.04.11.png


Captura_de_pantalla_2012-12-12_a_la_s__18.04.30.png


Captura_de_pantalla_2012-12-12_a_la_s__18.05.07.png




Vista final:

Captura_de_pantalla_2012-12-12_a_la_s__17.47.41.png


Configuración del servicio Apache, en donde se observa la dependencia de los recursos: en primer lugar se levanta la IP flotante, luego de eso se ejecuta el script de DRBD que setea el disco como Primary, a continuación se monta el disco DRBD, y finalmente se levanta el servicio Apache.


Captura_de_pantalla_2012-12-12_a_la_s__17.48.58.png




Archivo de configuración final (laboratorio): /etc/cluster/cluster.conf


<?xml version="1.0"?>
<cluster config_version="8" name="cluster_daniel">
<fence_daemon post_fail_delay="0" post_join_delay="3"/>
<clusternodes>
<clusternode name="nodo1.domain.com" nodeid="1" votes="1">
<fence>
<method name="1">
<device name="manual_nodo1" nodename="nodo1.domain.com"/>
</method>
</fence>
</clusternode>
<clusternode name="nodo2.domain.com" nodeid="2" votes="1">
<fence>
<method name="1">
<device name="manual_nodo2" nodename="nodo2.domain.com"/>
</method>
</fence>
</clusternode>
</clusternodes>
<cman expected_votes="1" two_node="1"/>
<fencedevices>
<fencedevice agent="fence_manual" name="manual_nodo1"/>
<fencedevice agent="fence_manual" name="manual_nodo2"/>
</fencedevices>
<rm>
<failoverdomains/>
<resources>
<ip address="192.168.11.81" monitor_link="1"/>
<script file="/etc/init.d/httpd" name="Apache"/>
<script file="/etc/init.d/drbddisk" name="DRBD"/>
<fs device="/dev/drbd0" force_fsck="0" force_unmount="1" fsid="62307" fstype="ext3" mountpoint="/var/www/html" name="data" options="" self_fence="1"/>
</resources>
<service autostart="1" exclusive="1" name="apache" recovery="relocate">
<ip ref="192.168.11.81">
<script ref="DRBD">
<fs ref="data">
<script ref="Apache"/>
</fs>
</script>
</ip>
</service>
</rm>
</cluster>

 


¿Tiene más preguntas? Enviar una solicitud

0 Comentarios

Inicie sesión para dejar un comentario.
Tecnología de Zendesk